<?php
/**
 * Copyright (c) 2018-present gotoBilling, Inc. All rights reserved.
 */

namespace XLite\Module\Omnifund\Payments\Model\Payment\Processor;

class OmnifundGateway extends \XLite\Model\Payment\Base\Online
{
		var $omni_gateway = 'https://secure.gotobilling.com/os/system/gateway/transact.php';
	
		# merchant validation
		var $omni_access_key;
		var $omni_access_key_secret;
		var $omni_ip_address;
		var $omni_debug = 0;
		var $omni_transaction_type;
		var $omni_customer_id;
		# optional
		var $omni_company;
		var $omni_first_name;
		var $omni_last_name;
		var $omni_address1;
		var $omni_address2;
		var $omni_city;
		var $omni_state;
		var $omni_zip;
		var $omni_country;
		var $omni_phone;
		var $omni_email;
	
		# BASIC TRANSACTION INFORMATION
		# required
		var $omni_invoice_id;
		var $omni_amount;
		# optional
		var $omni_process_date;
	
		# CREDIT CARD SPECIFIC
		# required
		var $omni_cc_number;
		var $omni_cc_exp;
		#optional
		var $omni_cc_name;
		var $omni_cc_type;
		var $omni_cc_cvv;
		var $omni_authorization;
	
		# ACH SPECIFIC
		# required
		var $omni_ach_payment_type;
		var $omni_ach_route;
		var $omni_ach_account;
		var $omni_ach_account_type;
		
		# optional
		var $omni_ach_serial;
		var $omni_state_fee;
		var $omni_ach_verification;
	
		var $omni_last_input = "";
		var $omni_data_sent = "";
		var $omni_error = "";
		var $omni_response = "";
	  
  	// Placeholder for main payment method.
    protected function doInitialPayment()
    {
    }

    function OmniProcess()
    {
				$data = $this->OmniGetUrlData(); 	// get the data to send

				$this->omni_data_sent = $data;
	
        try {
						$ch = curl_init();
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
						curl_setopt($ch, CURLOPT_POST, 1);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
						curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
						curl_setopt($ch, CURLOPT_URL, $this->omni_gateway); 
				
						$this->omni_response  = curl_exec($ch);
						curl_close($ch);

        } catch (Exception $e) {
            $this->omni_response = $e->getMessage();
						$this->omni_error = $e->getMessage();
        }
		
    }
    
    function OmniError() 
    {
        return $this->omni_error;
    }
    
    function OmniGetUrlData()
    {
       
	    $data =
				"access_key="			.	$this->omni_access_key . 
				"&access_key_secret="		.	$this->omni_access_key_secret . 
				"&ip_address="			.	$this->omni_ip_address . 
				"&x_transaction_type="	.	$this->omni_transaction_type . 
				"&x_customer_id="			.	$this->omni_customer_id . 
				"&x_invoice_id="			.	$this->omni_invoice_id . 
				"&x_amount="				.	$this->omni_amount;
		
				# optional
				if (isset($this->omni_relay_type))			$data .= "&x_relay_type="		. $this->omni_relay_type;
				if (isset($this->omni_relay_url))			$data .= "&x_relay_url="		. $this->omni_relay_url;
				if (isset($this->omni_debug))				$data .= "&x_debug="			. $this->omni_debug;
				if (isset($this->omni_company))				$data .= "&x_company="			. $this->omni_company;
				if (isset($this->omni_first_name))			$data .= "&x_first_name="		. $this->omni_first_name;
				if (isset($this->omni_last_name))			$data .= "&x_last_name="		. $this->omni_last_name;
				if (isset($this->omni_address1))				$data .= "&x_address1="			. $this->omni_address1;
				if (isset($this->omni_address2))				$data .= "&x_address2="			. $this->omni_address2;
				if (isset($this->omni_city))					$data .= "&x_city="				. $this->omni_city;
				if (isset($this->omni_state))				$data .= "&x_state="			. $this->omni_state;
				if (isset($this->omni_zip))					$data .= "&x_zip="				. $this->omni_zip;
				if (isset($this->omni_country))				$data .= "&x_country="			. $this->omni_country;
				if (isset($this->omni_phone))				$data .= "&x_phone="			. $this->omni_phone;
				if (isset($this->omni_email))				$data .= "&x_email="			. $this->omni_email;
				if (isset($this->omni_process_date))			$data .= "&x_process_date="		. $this->omni_process_date;
				if (isset($this->omni_cc_name))				$data .= "&x_cc_name="			. $this->omni_cc_name;
				if (isset($this->omni_cc_number))			$data .= "&x_cc_number="		. $this->omni_cc_number;
				if (isset($this->omni_cc_exp))				$data .= "&x_cc_exp="			. $this->omni_cc_exp;
				if (isset($this->omni_cc_type))				$data .= "&x_cc_type="			. $this->omni_cc_type;
				if (isset($this->omni_cc_cvv))				$data .= "&x_cc_cvv="			. $this->omni_cc_cvv;
				if (isset($this->omni_authorization))		$data .= "&x_authorization="	. $this->omni_authorization;
				if (isset($this->omni_ach_payment_type))		$data .= "&x_ach_payment_type="	. $this->omni_ach_payment_type;
				if (isset($this->omni_ach_route))			$data .= "&x_ach_route="		. $this->omni_ach_route;
				if (isset($this->omni_ach_account))			$data .= "&x_ach_account="		. $this->omni_ach_account;
				if (isset($this->omni_ach_account_type))		$data .= "&x_ach_account_type="	. $this->omni_ach_account_type;
				if (isset($this->omni_ach_serial))			$data .= "&x_ach_serial="		. $this->omni_ach_serial;
				if (isset($this->omni_state_fee))			$data .= "&x_state_fee="		. $this->omni_state_fee;
				if (isset($this->omni_ach_verification))		$data .= "&x_ach_verification="	. $this->omni_ach_verification;

        return $data;
    }
    
    //each field must be urlencoded to send with a post.  DO NOT set the variables without using these functions, as you will most
    //likely run into errors
    
    # merchant validation
	function OmniSetAccessKey( $access_key )
	{
		$this->omni_access_key = $this->OmniPrepareData( $access_key );
	}
	function OmniSetAccessKeySecret( $access_key_secret) 
	{
		$this->omni_access_key_secret = $this->OmniPrepareData( $access_key_secret );
	} 
	function OmniSetIpAddress( $ip )
	{
		$this->omni_ip_address = $ip;
	} 
	
	function OmniSetDebug( $debug )
	{
		$this->omni_debug = $debug;
	} 
	
	function OmniSetRelayUrl( $url )
	{
		$this->omni_relay_url = $url;
	} 
	
	function OmniSetRelayType( $type )
	{
		$this->omni_relay_type = strtolower($type);
	} 
	
	# Customer Fields
	function OmniSetCustomerId( $id ) 
	{
		$this->omni_customer_id = $this->OmniPrepareData( $id );
	} 
	
	function OmniSetCompany( $company ) 
	{
		$this->omni_company = $this->OmniPrepareData( $company );
	} 
	
	function OmniSetFirstName( $first_name )
	{
		$this->omni_first_name = $this->OmniPrepareData( $first_name );
	} 
	
	function OmniSetLastName( $last_name )
	{
		$this->omni_last_name = $this->OmniPrepareData( $last_name );
	} 
	
	function OmniSetAddress1( $address1 )
	{
		$this->omni_address1 = $this->OmniPrepareData( $address1 );
	} 
	
	function OmniSetAddress2( $address2 )
	{
		$this->omni_address2 = $this->OmniPrepareData( $address2 );
	} 
	
	function OmniSetCity( $city )
	{
		$this->omni_city = $this->OmniPrepareData( $city );
	} 
	
	function OmniSetState( $state )
	{
		$this->omni_state = $this->OmniPrepareData( $state );
	} 
	
	function OmniSetZipCode( $zip )
	{
		$this->omni_zip = $this->OmniPrepareData( $zip );
	} 
	
	function OmniSetCountry( $country )
	{
		$this->omni_country = $this->OmniPrepareData( $country );
	} 
	
	function OmniSetPhone( $phone )
	{
		$this->omni_phone = $this->OmniPrepareData( $phone );
	} 
	
	function OmniSetEmail( $email )
	{
		 $this->omni_email = $this->OmniPrepareData( $email );
	}  
	
	# Transaction Fields
	# set transaction type; CC: AS,CR,DS,ES,VO  ACH: DH,DC;
	function OmniSetTransactionType( $transaction_type )
	{
		$this->omni_transaction_type = $this->OmniPrepareData( $transaction_type );
	} 
	
	function OmniSetInvoiceId( $invoice_id )
	{
		$this->omni_invoice_id = $this->OmniPrepareData( $invoice_id );
	} 
	
	function OmniSetAmount( $amount )
	{
		$this->omni_amount = $this->OmniPrepareData( $amount ); 
	} 
	
	function OmniSetProcessDate( $date )
	{
		$this->omni_process_date = $this->OmniPrepareData( $date );
	} 
	
	# Fee Fields
	# set fees
	function OmniSetStateFee( $state_fee )
	{
		$this->omni_state_fee = $this->OmniPrepareData( $state_fee );
	} 
	
	# Credit Card Fields
	function OmniSetCcName( $name )
	{
		$this->omni_cc_name = $this->OmniPrepareData( $name );
	} 
	function OmniSetCcType( $type )
	{
		$this->omni_cc_type = $this->OmniPrepareData( $type );
	} 
	function OmniSetCcNumber( $cc_number )
	{
		$this->omni_cc_number = $this->OmniPrepareData( $cc_number );
	} 
	
	function OmniSetCcExpiration( $cc_exp )
	{
		$this->omni_cc_exp = $this->OmniPrepareData( $cc_exp );
	} 
	
	function OmniSetCcVerification( $cc_cvv )
	{
		$this->omni_cc_cvv = $this->OmniPrepareData( $cc_cvv );
	} 
	
	
	function OmniSetAuthorization( $auth )
	{
		$this->omni_authorization = $this->OmniPrepareData( $auth );
	} 
	
	# ACH FIELDS
	# length=2; PPD,WEB,TEL,RCK,ARC
	function OmniSetAchPaymentType( $ach_type )
	{
		$this->omni_ach_payment_type = $this->OmniPrepareData( $ach_type );
	} 
	
	
	function OmniSetAchRoute( $ach_route )
	{
		$this->omni_ach_route = $this->OmniPrepareData( $ach_route );
	} 
	
	function OmniSetAchAccount( $ach_account )
	{
		$this->omni_ach_account = $this->OmniPrepareData( $ach_account );
	} 
	
	
	function OmniSetAchAccountType( $ach_account_type )
	{
		$this->omni_ach_account_type = $this->OmniPrepareData( $ach_account_type );
	} 
	
	
	function OmniSetAchSerial( $ach_serial )
	{
		$this->omni_ach_serial = $this->OmniPrepareData( $ach_serial );
	}
	
	function OmniSetAchVerification( $verify ) {
		$this->omni_ach_verification = $verify;
	} 
	
	// PREPARE SUBMITTED INFORMATION
	function OmniPrepareData( $input ) 
	{

		$this->omni_last_input = var_export($input, true);

		if (is_array($input))
			$output = urlencode(implode(' ', $input));
		else
			$output = urlencode($input);
		return $output;
	}

	// Get Returned Information
	function OmniGetStatus() 
	{
		$this->omni_last_input = $this->omni_response;
		preg_match("/<status>(.*)<\/status>/", $this->omni_response, $status);
		return $status[1];
	}
	
	function OmniGetOrderNumber() 
	{
		preg_match("/<order_number>(.*)<\/order_number>/", $this->omni_response, $order);
		return $order[1];
	}
	
	function OmniGetTerminationCode() 
	{
		preg_match("/<term_code>(.*)<\/term_code>/", $this->omni_response, $termCode);
		return $termCode[1];
	}
	
	function OmniGetTransactionDate() 
	{
		preg_match("/<tran_date>(.*)<\/tran_date>/", $this->omni_response, $tranDate);
		return $tranDate[1];
	}
	
	function OmniGetTransactionTime() 
	{
		preg_match("/<tran_time>(.*)<\/tran_time>/", $this->omni_response, $tranTime);
		return $tranTime[1];
	}
	
	function OmniGetTransactionAmount() 
	{
		preg_match("/<tran_amount>(.*)<\/tran_amount>/", $this->omni_response, $tranAmt);
		return $tranAmt[1];
	}
	
	function OmniGetInvoiceId() 
	{
		preg_match("/<invoice_id>(.*)<\/invoice_id>/", $this->omni_response, $invoiceId);
		return $invoiceId[1];
	}
	
	function OmniGetTerminationDescription() 
	{
		preg_match("/<description>(.*)<\/description>/", $this->omni_response, $invoiceId);
		return $invoiceId[1];
	}
	
	function OmniGetAuthCode() 
	{
		preg_match("/<auth_code>(.*)<\/auth_code>/", $this->omni_response, $invoiceId);
		return $invoiceId[1];
	}
	
}
